﻿using Microsoft.AnalysisServices.AdomdClient;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SSASCLR
{
    class Class2
    {
        public static DataTable GetResult(string PROD)
        {
            DataTable result = new DataTable();
            
            AdomdConnection conn = new AdomdConnection(@"Provider=MSOLAP.3;Integrated Security=SSPI;Persist Security Info=True;Initial Catalog=AdventureWorksDW2012Multidimensional-EE;Data Source=.");
            conn.Open();

            StringBuilder sb = new StringBuilder();
            sb.AppendLine("SELECT FLATTENED ");
            sb.AppendLine("PredictAssociation([Association].[v Assoc Seq Line Items],INCLUDE_STATISTICS,3) ");
            sb.AppendLine("FROM ");
            sb.AppendLine("[Association] ");
            sb.AppendLine("NATURAL PREDICTION JOIN ");
            sb.AppendLine("(SELECT (SELECT '"+PROD+"' AS [Model] ");
            sb.AppendLine(") AS [v Assoc Seq Line Items]) AS t");

            AdomdCommand comm = new AdomdCommand(sb.ToString(), conn);
            AdomdDataReader dr = comm.ExecuteReader();


            result.Columns.Add("C1");
            result.Columns.Add("C2");
            result.Columns.Add("C3");
            result.Columns.Add("C4");

            while (dr.Read())
            {
                DataRow dtr = result.NewRow();
                dtr[0] = dr[0];
                dtr[1] = dr[1];
                dtr[2] = dr[2];
                dtr[3] = dr[3];

                result.Rows.Add(dtr);
            }


            return result;
        }
    }
}
